﻿

namespace NRuler.Test
{
    using System.Collections.ObjectModel;
    using System.IO;
    using System.Runtime.Serialization;
    using System.Runtime.Serialization.Formatters.Binary;
    using NRuler.Common;
    using NRuler.Rete;
    using NUnit.Framework;
    using Test.Common;


    [TestFixture]
    public class PerfTest
    {
        [SetUp]
        public void Init()
        {            
        }

        [TearDown]
        public void Dispose()
        {

        }

        [Test]
        [Category("Performance")]
        [Ignore]
        public void Test_1()
        {  
            int ruleNumber = 5000000;
            int factNumber = 1000000;

            Logger.Info("Generating Rule Engine Problem.");
            ProblemGen gen = new ProblemGen("rules.dat", ruleNumber, factNumber);
            gen.Generate();
            Logger.Info("{0} RULES, {1} FACTS GENERATED.", ruleNumber, factNumber);

            int ruleNum;
            int factNum;

            Agenda agenda = new Agenda();

            Logger.Info("Load rules & facts into memory.");
           
            Collection<Production> productions = new Collection<Production>();
            Collection<WME> facts = new Collection<WME>();
            IFormatter formatter = new BinaryFormatter();
            FileStream stream = new FileStream("rules.dat", FileMode.Open, FileAccess.Read, FileShare.None);

            ruleNum = (int)formatter.Deserialize(stream);
            factNum = (int)formatter.Deserialize(stream);

            for (int i = 0; i < ruleNum; i++)
            {
                productions.Add((Production)formatter.Deserialize(stream));
            }

            for (int i = 0; i < factNum; i++)
            {
                facts.Add((WME)formatter.Deserialize(stream));
            }

            Logger.Info("Add rules & facts into agenda.");
            agenda.AddProductions(productions);
            agenda.AddFacts(facts);   

            Logger.Info("Fire rules.");
            agenda.Run();

            Logger.Info("InitialFacts: {0}.", agenda.InitialFacts);
            Logger.Info("InferredFacts: {0}.", agenda.InferredFacts);
            Logger.Info("ActivatedRuleCount: {0}.", agenda.ActivatedRuleCount);            

        }
    }
    
}
